import sys
from PIL import Image
import pandas as pd
import datetime
import time

cam_sensative=50 #100 low senstivity
detection_count= 5 # how many time checking
time_to_enter=1  # time given for the person to enter
time_to_exit=1  # time given for the person to exit      

#------------------- Text To Speech
import pyttsx3 
converter = pyttsx3.init() # Initialize the converter 
converter.setProperty('rate', 200)  # Sets speed percent 
converter.setProperty('volume', 1)  # Set volume 0-1

from time import sleep
from gpiozero import LED, Button

#------------------- Wiring
#right side
in_button = Button(16)

# left side
out_button = Button(26)

print("close")
converter.say("close")
converter.runAndWait()

#-------------------- Image Processing
import cv2 #openCV 
import numpy as np 
import os
recognizer = cv2.face.LBPHFaceRecognizer_create()
recognizer.read('trainer.yml')
cascadePath = "haarcascade_frontalface_default.xml"
faceCascade = cv2.CascadeClassifier(cascadePath);
font = cv2.FONT_HERSHEY_SIMPLEX
#iniciate id counter
id = 0
# names related to ids: example ==> Jack: id=1,  etc
names = ['None', 'mohammad', 'ID_2', 'ID_3', 'ID_4','ID_5','ID_6','ID_7','ID_8','Fahad','Fahad','ID_11','ID_12','ID_13'] 

#Enter CAMERA "CAM_1"
# Initialize and start realtime video capture 
cam_1 = cv2.VideoCapture(0)
cam_1.set(3, 640) # set video widht
cam_1.set(4, 480) # set video height
# Define min window size to be recognized as a face
minW = 0.1*cam_1.get(3)
minH = 0.1*cam_1.get(4)
flag_in = 0

#Exit CAMERA "CAM_2"
# Initialize and start realtime video capture
cam_2 = cv2.VideoCapture(2)
cam_2.set(3, 640) # set video widht
cam_2.set(4, 480) # set video height
# Define min window size to be recognized as a face
minW = 0.1*cam_2.get(3)
minH = 0.1*cam_2.get(4)
flag_out = 0

while True:
   
    if (in_button.is_pressed == 1 and flag_in < detection_count):
        print("cam_1 is ON, Please scan your face")

        while flag_in < detection_count:
            ret1, img1 =cam_1.read()
            sleep(0.5)
            if ret1 == True:
                gray = cv2.cvtColor(img1,cv2.COLOR_BGR2GRAY)
                faces = faceCascade.detectMultiScale(gray,scaleFactor = 1.2,minNeighbors = 5,minSize = (int(minW), int(minH)),)
                for(x,y,w,h) in faces:
                    cv2.rectangle(img1, (x,y), (x+w,y+h), (0,255,0), 2)
                    id, confidence = recognizer.predict(gray[y:y+h,x:x+w])
                    # Check if confidence is less them 100 ==> "0" is perfect match 
                    if (confidence < cam_sensative):
                        id_Number = id
                        id = names[id_Number]
                        confidence = "  {0}%".format(round(100 - confidence))
                        flag_in=flag_in+1
                        print("Accepting picture",flag_in )
                        sleep(0.1)
                    else:
                        id = "unknown"
                        confidence = "  {0}%".format(round(100 - confidence))

                    cv2.putText(img1, str(id), (x+5,y-5), font, 1, (255,255,255), 2)
                    cv2.putText(img1, str(confidence), (x+5,y+h-5), font, 1, (255,255,0), 1)  
                cv2.imshow('camera',img1)
                k = cv2.waitKey(10) & 0xff # Press 'ESC' for exiting video
                if k == 27:
                    break
            if ret1 == False:
                print("cam 1 failed >> wait or restart")
                sleep(0.5)
                continue

    if flag_in >= detection_count:
        #cam_1.release()
        cv2.destroyAllWindows()
        
        ts = time.time()
        date = datetime.datetime.fromtimestamp(ts).strftime('%d-%m-%Y')
        timeStamp = datetime.datetime.fromtimestamp(ts).strftime('%H:%M')

        #   open the attendance file for update
        f = open("AttendanceFile.csv","a+")
        f.write(str(id_Number)+','+ str(id)+','+ str(date)+','+ str(timeStamp)+ ",Enter"+'\n')
        f.close()
        
        #print("Autherized >> the Door is opened")
        #converter.say("Autherized >> the Door is opened")
        #converter.runAndWait()
        #sleep(0.5)
        print("Welcome ",id)
        converter.say("welcome")
        converter.runAndWait()
        sleep(0.5)
        converter.say(id)
        converter.runAndWait()

        #print("Please come inside")
        #converter.say("Please come inside")
        #converter.runAndWait()
        sleep(time_to_enter)
        print("okay .. Next")
        flag_in=0
        
        
    if (out_button.is_pressed == 1 and flag_out < detection_count):
        print("cam_2 ON Exit")
        while flag_out < detection_count:
            ret2, img2 =cam_2.read()
            sleep(0.5)
            if ret2 == True:
                gray = cv2.cvtColor(img2,cv2.COLOR_BGR2GRAY)
                faces = faceCascade.detectMultiScale(gray,scaleFactor = 1.2,minNeighbors = 5,minSize = (int(minW), int(minH)),)
                for(x,y,w,h) in faces:
                    cv2.rectangle(img2, (x,y), (x+w,y+h), (0,255,0), 2)
                    id, confidence = recognizer.predict(gray[y:y+h,x:x+w])
                    # Check if confidence is less them 100 ==> "0" is perfect match 
                    if (confidence < cam_sensative):
                        id_Number = id
                        id = names[id_Number]
                        confidence = "  {0}%".format(round(100 - confidence))
                        #GPIO.output(relay, 0)
                        flag_out=flag_out+1
                        print("Accepting picture",flag_out )
                        sleep(0.1)
                    else:
                        id = "unknown"
                        confidence = "  {0}%".format(round(100 - confidence))

                    cv2.putText(img2, str(id), (x+5,y-5), font, 1, (255,255,255), 2)
                    cv2.putText(img2, str(confidence), (x+5,y+h-5), font, 1, (255,255,0), 1)  
                cv2.imshow('camera',img2)
                k = cv2.waitKey(10) & 0xff # Press 'ESC' for exiting video
                if k == 27:
                    break

            if ret2 == False:
                print("cam 2 failed >> wait or restart")
                sleep(0.5)
                continue

    elif flag_out >= detection_count:
        #cam_2.release()
        cv2.destroyAllWindows()
        
        ts = time.time()
        date = datetime.datetime.fromtimestamp(ts).strftime('%d-%m-%Y')
        timeStamp = datetime.datetime.fromtimestamp(ts).strftime('%H:%M')

        #   open the attendance file for update
        f = open("AttendanceFile.csv","a+")
        f.write(str(id_Number)+','+ str(id)+','+ str(date)+','+ str(timeStamp)+ ",Exit"+'\n')
        f.close()
        
        #print("Autherized >> the Door is opened")
        #converter.say("Autherized >> the Door is opened")
        #converter.runAndWait()
        #sleep(0.5)
        print("Goodbye ",id)
        converter.say("Goodbye")
        converter.runAndWait()
        sleep(0.5)
        converter.say(id)
        converter.runAndWait()
        print("Have a day")
        
        print("wait to go outside")
        sleep(time_to_exit)
        print("okay .. Next")
        flag_out=0


